/* SYSTEM USER */
CREATE USER GRIESMAYER PROFILE "DEFAULT" IDENTIFIED BY "oracle"
DEFAULT TABLESPACE USERS
TEMPORARY TABLESPACE TEMP
ACCOUNT UNLOCK;

GRANT SELECT ANY DICTIONARY TO GRIESMAYER;
GRANT UNLIMITED TABLESPACE TO GRIESMAYER;
GRANT CONNECT TO GRIESMAYER;
GRANT RESOURCE TO GRIESMAYER;






/* GRIESMAYER USER */
DROP TABLE GRIESMAYER_OWNERSHIP;
DROP TABLE GRIESMAYER_CATEGORY;
DROP TABLE GRIESMAYER_OWNERSHIP2;
commit;

CREATE TABLE GRIESMAYER_OWNERSHIP
(
       CUSTOMER_ID   INTEGER,
       NAME          VARCHAR(10),
       HOUSES        INTEGER,
       APPARTMENTS   INTEGER
);

commit;

INSERT INTO GRIESMAYER_OWNERSHIP VALUES (1, 'Thomas', 2,    1);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (2, 'Werner', 1,    2);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (3, 'Hans',   2,    2);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (4, 'Susi',   1,    0);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (5, 'Alex',   1,    NULL);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (6, 'Martin', NULL, 2);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (7, 'Kurt',   NULL, NULL);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (8, 'Maria',  0,    NULL);
INSERT INTO GRIESMAYER_OWNERSHIP VALUES (9, 'Verena', NULL, 0);

commit;

CREATE TABLE GRIESMAYER_CATEGORY
(
       NUMBEROF    INTEGER,
       CATEGORY    VARCHAR(10)
);

INSERT INTO GRIESMAYER_CATEGORY VALUES (NULL, 'unknown');
INSERT INTO GRIESMAYER_CATEGORY VALUES (0,    'nothing');
INSERT INTO GRIESMAYER_CATEGORY VALUES (1,    'OK');
INSERT INTO GRIESMAYER_CATEGORY VALUES (2,    'good');
INSERT INTO GRIESMAYER_CATEGORY VALUES (3,    'wealthy');
INSERT INTO GRIESMAYER_CATEGORY VALUES (4,    'rich');

commit;



/* Part 1 */
SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES<>0
UNION
SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES=0;

SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES<>0;

SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES=0;

SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES IS NULL;

SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES<>0
UNION
SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES=0
UNION
SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES is NULL;



/* Part 2 */
SELECT * FROM GRIESMAYER_OWNERSHIP WHERE HOUSES=APPARTMENTS;



/* Part 3 */
SELECT NAME,
       HOUSES,
  	   CATEGORY
FROM   GRIESMAYER_OWNERSHIP b
       INNER JOIN
       GRIESMAYER_CATEGORY a
       ON b.HOUSES = a.NUMBEROF;



/* Part 4 */
SELECT NAME,
       HOUSES,
  	   CATEGORY
FROM   GRIESMAYER_OWNERSHIP b
       LEFT OUTER JOIN
       GRIESMAYER_CATEGORY a
       ON b.HOUSES = a.NUMBEROF;

	   
	   
/* Part 5 */
SELECT count(*),
       count(HOUSES),
       sum(HOUSES),
       avg(HOUSES),
       min(HOUSES),
       max(HOUSES)
FROM   GRIESMAYER_OWNERSHIP;



/* Part 6 */
SELECT *
FROM   GRIESMAYER_OWNERSHIP
WHERE  HOUSES<1 OR APPARTMENTS<1;



/* Part 7 */
SELECT distinct HOUSES FROM GRIESMAYER_OWNERSHIP;



/* Part 8 */
CREATE TABLE GRIESMAYER_OWNERSHIP2
(
       GRIESMAYER_CATEGORY      INTEGER UNIQUE,
       REICHTUM    VARCHAR(10)
);

INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (NULL, 'unknown');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (0,    'nothing');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (1,    'OK');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (2,    'good');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (3,    'wealthy');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (4,    'rich');
commit;
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (NULL, 'no value');
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (NULL, 'unknown');
commit;
INSERT INTO GRIESMAYER_OWNERSHIP2 VALUES (1,    'A');

SELECT *
FROM   GRIESMAYER_OWNERSHIP2;



/* Part 9 */
SELECT NAME,
       HOUSES,
  	   CATEGORY
FROM   GRIESMAYER_OWNERSHIP b
       INNER JOIN
       GRIESMAYER_CATEGORY a
       ON coalesce(b.HOUSES, -1) = coalesce(a.NUMBEROF, -1);



/* Part 10 */
SELECT NAME,
       HOUSES,
  	   CATEGORY
FROM   GRIESMAYER_OWNERSHIP b
       INNER JOIN
       GRIESMAYER_CATEGORY a
       ON coalesce(b.HOUSES, 1) = coalesce(a.NUMBEROF, 1);

